/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package gov.lbl.nest.plugin.overlay;

import static org.junit.jupiter.api.Assertions.assertTrue;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import org.gradle.testkit.runner.BuildResult;
import org.gradle.testkit.runner.GradleRunner;
import org.gradle.testkit.runner.TaskOutcome;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.io.TempDir;

/**
 * A simple functional test for the 'gov.lbl.nest.overlay' plugin.
 */
class WarOverlayPluginFunctionalTest {
    @TempDir
    File projectDir;

    private File getBuildFile() {
        return new File(projectDir,
                        "build.gradle");
    }

    private File getSettingsFile() {
        return new File(projectDir,
                        "settings.gradle");
    }

    @Test
    void canRunTask() throws IOException {
        writeString(getSettingsFile(),
                    "");
        writeString(getBuildFile(),
                    "plugins {" + "  id('gov.lbl.nest.overlay')"
                                    + "}");

        // Run the build
        GradleRunner runner = GradleRunner.create();
        runner.forwardOutput();
        runner.withPluginClasspath();
        runner.withArguments("overlay");
        runner.withProjectDir(projectDir);
        BuildResult result = runner.build();
        assertTrue(!result.tasks(TaskOutcome.SUCCESS)
                          .isEmpty());

        // Verify the result
//        assertTrue(result.getOutput()
//                         .contains("Hello from plugin 'gov.lbl.nest.overlay'"));
    }

    private void writeString(File file,
                             String string) throws IOException {
        try (Writer writer = new FileWriter(file)) {
            writer.write(string);
        }
    }
}
